import { GluegunToolbox } from 'gluegun';
import { IPrintableStep } from '../models/SidiModel';
import { SidiConfig } from '../main/SidiConfig';
/**
 * Convert string aray to printable array
 * That is to say, to print items wit hid and allow user to select item with id
 *
 * @param toolbox: GluegunToolbox
 * @param path of folder where we have steps to print
 */
export declare function getPrintableStepsFromFolder(toolbox: GluegunToolbox, path: string): IPrintableStep[];
/**
 * Convert string aray to printable array
 * That is to say, to print items wit hid and allow user to select item with id
 *
 * @param toolbox: GluegunToolbox
 * @param array to convert
 */
export declare function getPrintableStepsFromArray(toolbox: GluegunToolbox, array: string[]): IPrintableStep[];
/**
 * Check if have already a key saved in an array
 *
 * @param array to check
 * @param key to check if already saved
 */
export declare function checkIfArrayContainKey(array: any[], key: string): boolean;
/**
 * Check if the text contain any blanck space
 *
 * @param text to check
 * @return return true if we have any blank space
 */
export declare function hasWhiteSpace(text: string): boolean;
/**
 * Display text as an hyperlink, to be able to click directly from de CLI (if supported)
 *
 * @param text to display as a link
 */
export declare function supportHyperlink(text: string): string;
/**
 * Save or not in sidiConfig cache file the key
 * If the key is in sidiConfigUnwantedKeys and/or workflowConfigUnwantedKeys
 * The key will not be saved
 *
 */
export declare function sidiConfigKeyReplacer(key: any, value: any): any;
/**
 * Check if the array is undefined or empty
 *
 * @param array to check
 * @return true if is not empty
 */
export declare function arrayNotEmpty(array?: Array<any> | string): boolean;
/**
 * Check if at the end of the process, SIDI created two yamls (main + variables)
 *
 * @param sidiConfig
 * @param workflows set for the current cicd config
 */
export declare function checkIfProperlyCreated(sidiConfig: SidiConfig, workflows: {
    [key: string]: any;
}): boolean;
/**
 * Helper to sort keys in object
 *
 * @param object to sort
 */
export declare function objectSorter(object: any): {};
export declare function sleep(time: number): Promise<unknown>;
